<?php
namespace Teknisa\CTB\Controllers;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Ctb00700RelatoriosContabeis extends \Zeedhi\Framework\Controller\Report {

    protected $novoCodigo;
    protected $procedureNutriente;
    protected $parameterBagColumns;
    protected $entityManager;
    protected $qr2Strategy;
    protected $nrsequnutr;
    protected $cdfilial;
    protected $nrorg;
    protected $connection;

    public function __construct($reportService, $novoCodigo, $entityManager, $qr2Strategy, $connection) {

        $this->reportService      = $reportService;
        $this->novoCodigo         = $novoCodigo;
        $this->entityManager      = $entityManager;
        $this->qr2Strategy        = $qr2Strategy;
        $this->connection         = $connection;

    }

    protected $reportMapping = array (
        'CTB23000' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                'NRORG'              => 'P_NRORG',
                'CDEMPRESA'          => 'P_CDEMPRESA',
                'DTINIPERIODO'       => 'P_DTINICIAL',
                'DTFIMPERIODO'       => 'P_DTFINAL',
                'NRPAGINA'           => 'P_NRPAGINA',
                'CDCONTCTBLINI'      => 'P_CDCONTINI',
                'CDCONTCTBLFIN'      => 'P_CDCONTFIM',
                'TIPODESALDO'        => 'P_IDTIPOSALDO',
                'DESCONSIDERA'       => 'P_IDENCERRAMENTO',

            ),
        ),
        'CTB23001' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
               // 'NRORG'              => 'P_NRORG',
                'CDEMPRESA'          => 'P_CDEMPRESA',
                'DTINIPERIODO'       => 'P_DTSALDINI',
                'DTFIMPERIODO'       => 'P_DTSALDFIM',
                'CDCONTCTBLINI'      => 'P_CDCONTINI',
                'CDCONTCTBLFIN'      => 'P_CDCONTFIM',
                'TIPODESALDO'        => 'P_IDTIPOSALDO'
            ),
        ),
        'CTB21000' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                'NRORG'              => 'P_NRORG',
                'CDEMPRESA'          => 'CDEMPR',
                'DTINIPERIODO'       => 'P_DTINICIAL',
                'DTFIMPERIODO'       => 'P_DTFINAL',
                //'DTINIPERIODO'       => 'P_STDATAINI',
                //'DTFIMPERIODO'       => 'P_STDATAFIM',
                'NRPAGINA'           => 'P_PAGINA',
                'DIARIO'             => 'P_DIARIO',
                'ULTPAGINA'          => 'P_ULTPAGINA'
            ),
        ),
        'CTB21002' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                'NRORG'              => 'P_NRORG',
                'CDEMPRESA'          => 'CDEMPR',
                'DTINIPERIODO'       => 'P_DTINICIAL',
                'DTFIMPERIODO'       => 'P_DTFINAL',
                //'DTINIPERIODO'       => 'P_STDATAINI',
                //'DTFIMPERIODO'       => 'P_STDATAFIM',
                'NRPAGINA'           => 'P_PAGINA',
                'DIARIO'             => 'P_DIARIO'
            ),
        ),
        'CTB23004' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                'NRORG'              => 'P_NRORG',
                'CDEMPRESA'          => 'P_STEMPRESA',
                'DTINIPERIODO'       => 'P_DTINICIAL',
                'DTFIMPERIODO'       => 'P_DTFINAL',
                'NRPAGINA'           => 'P_NRPAGINA',
                'CDCONTCTBLINI'      => 'P_CDCONTINI',
                'CDCONTCTBLFIN'      => 'P_CDCONTFIM',
                'TIPODESALDO'        => 'P_IDTIPOSALDO',
                'DESCONSIDERA'       => 'P_IDENCERRAMENTO',

            ),
        ),
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        set_time_limit(14400);
        ini_set("defaut_socket_timeout", 0);
     /*   $row['DTFIMPERIODO'] ='31/12/2021' ;

        $row['DTINIPERIODO'] ='01/01/2021' ;
        $row['CDEMPRESA'] ='_01_02_03_06_07_09_16_18_22_23_25_65_67_70_' ;*/


        try {
            ini_set('default_socket_timeout', 14400);
        } catch (\Exception $e) {}
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
    }
}