<?php
namespace Teknisa\CTB\Modules\Saldos\Services;

use Doctrine\ORM\EntityManager;

class Ctb44200RazaoGerencialService {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function find($row){
        
       $cdempresa  = isset($row['CDEMPRESA'])  ? is_array($row['CDEMPRESA'])  ? implode('_', $row['CDEMPRESA'])  : $row['CDEMPRESA']  : 'T';
       $cdfilial   = isset($row['CDFILIAL'])   ? is_array($row['CDFILIAL'])   ? implode('_', $row['CDFILIAL'])   : $row['CDFILIAL']   : 'T';
       $cdcentcust = isset($row['CDCENTCUST']) ? is_array($row['CDCENTCUST']) ? implode('_', $row['CDCENTCUST']) : $row['CDCENTCUST'] : 'T';
       $cdareagere = isset($row['CDAREAGERE']) ? is_array($row['CDAREAGERE']) ? implode('_', $row['CDAREAGERE']) : $row['CDAREAGERE'] : 'T';
      
       $param = array(
            ':CDEMPRESA'  => $cdempresa,
            ':CDFILIAL'   => $cdfilial,
            ':CDAREAGERE' => $cdareagere,
            ':CDCONTINI'  => $row['CDCONTINI'],
            ':CDCONTFIN'  => $row['CDCONTFIN'],
            ':DTINICIAL'  => $row['DTLANCCONT'][0],
            ':DTFINAL'    => $row['DTLANCCONT'][1],
            ':CDCENTCUST' => $cdcentcust
       );
        
       $aux = $this->connection->fetchAll(self::FIND, $param);
       return $aux;
    }
   
   const FIND = "
SELECT B.NRORG,
  B.CDFILIAL CDFILIAL2,
  B.CDCENTCUST CDCENTCUST2,
  B.CDCONTCTBL,
  B.DTLANCCONT,
  B.CDEMPRESA,
  B.DSHISTLANC,
  B.NRLANCCONT
  ||' ' AS NRLANCCONT,
  B.CDDOCUCONT  ||' ' AS CDDOCUCONT,
  B.NMCONTCTBL,
  0 AS VRSALDCCUS,
  B.VRLANCCUST,
  B.DTCOMPCUSTO,
  NVL(C.NMRAZSOCCLIE, F.NMRAZSOCFORN) AS NMRAZSOCFORN,
  NMCENTCUST,
  NMFILIAL,
  EMPRESA.NMEMPRESA,
  'COMUM' TIPO,
  1 CARACTER
FROM CENTCUST,
  FILIAL,
  EMPRESA,
  NOTAFISCAL N,
  FORNECEDOR F,
  CLIENTE C,
  (SELECT LANCCONT.NRORG,
    LANCCONT.CDEMPRESA,
    LANCCONT.DTLANCCONT,
    LANCCONT.CDCONTCTBL,
    LANCCONT.DSHISTLANC,
    LANCCONT.NRLANCCONT,
    LANCCONT.CDDOCUCONT,
    LANCCONT.CDCONTCOME,
    CONTCTBL.NMCONTCTBL,
    LANCCCUSTO.CDFILIAL,
    LANCCCUSTO.CDCENTCUST,
    LANCCCUSTO.VRLANCCUST,
    LANCCCUSTO.DTCOMPCUSTO
  FROM CONTCTBL,
    LANCCONT,
    LANCCCUSTO,
    CENTCUST,
    (SELECT CDFILIAL
    FROM FILIAL
    WHERE ( ( INSTR(:CDAREAGERE, FILIAL.CDAREAGERE) <> 0 )
    OR ( :CDAREAGERE                                 = 'T' ) )
    AND ( ( INSTR(:CDFILIAL, FILIAL.CDFILIAL)       <> 0 )
    OR ( :CDFILIAL                                   = 'T' ) )
    ) FILIAL
  WHERE (( instr(:CDEMPRESA, LANCCONT.CDEMPRESA )   <> 0)
  OR (:CDEMPRESA                                     = 'T'))
  AND ( ( INSTR(:CDCENTCUST, LANCCCUSTO.CDCENTCUST) <> 0 )
  OR :CDCENTCUST                                     = 'T' )
  AND ( LANCCCUSTO.DTCOMPCUSTO BETWEEN :DTINICIAL AND :DTFINAL )
  AND ( LANCCONT.CDCONTCTBL BETWEEN :CDCONTINI AND :CDCONTFIN || 'ZZZZZZZZZZZZZZZZZZZZ' )
  AND ( LANCCCUSTO.NRLANCCONT = LANCCONT.NRLANCCONT )
  AND ( LANCCCUSTO.CDEMPRESA  = LANCCONT.CDEMPRESA )
  AND ( LANCCCUSTO.NRSEQLANC  = LANCCONT.NRSEQLANC )
  AND ( LANCCCUSTO.CDFILIAL   = FILIAL.CDFILIAL )
  AND ( LANCCCUSTO.CDCENTCUST = CENTCUST.CDCENTCUST )
  AND ( LANCCONT.CDCONTCTBL   = CONTCTBL.CDCONTCTBL )
  ) B
WHERE ((INSTR(:CDEMPRESA, EMPRESA.CDEMPRESA) <> 0 )
OR :CDEMPRESA                                 = 'T')
AND ( B.CDFILIAL                              = FILIAL.CDFILIAL )
AND ( B.CDCENTCUST                            = CENTCUST.CDCENTCUST )
AND ( N.CDEMPRESA (+)                         = B.CDEMPRESA )
AND ( N.NRLANCTBDOC (+)                       = B.NRLANCCONT )
AND ( F.CDFORNECED (+)                        = N.CDFORNECED )
AND ( C.CDCLIENTE (+)                         = N.CDCLIENTE )
AND (EMPRESA.CDEMPRESA                        = B.CDEMPRESA)                   
ORDER BY 1,
  2,
  3,
  4";
}
        
  