/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FILITIPOCARD                                             */
/* Tabela : FILITIPOCARD                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 08/03/2005 - Henrique Dias Borges                                          */
/*                                                                            */
/******************************************************************************/
IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FILITIPOCARD' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_FILITIPOCARD
GO

CREATE TRIGGER DTULTATU_FILITIPOCARD
ON FILITIPOCARD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'FILITIPOCARD', NULL, 'CDFILCENTPME='+ CDFILCENTPME+';'+'CDTIPOCARD='+ CDTIPOCARD+';'+'CDFILIAL='+ CDFILIAL+';',GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE FILITIPOCARD
      SET DTULTATUFTCA = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(FILITIPOCARD.CDFILCENTPME,0) = ISNULL(INSERTED.CDFILCENTPME,0)) AND
            (ISNULL(FILITIPOCARD.CDTIPOCARD,0) = ISNULL(INSERTED.CDTIPOCARD,0)) AND
            (ISNULL(FILITIPOCARD.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0))   ;
   END;
END;
GO
